# PSmartObject Class Reference

This is the base class for objects that use the smart pointer system. More...

`#include <smartptr.h>`

Inheritance diagram for PSmartObject:

List of all members.

## Public Member Functions

| PSmartObject ()
| Construct a new smart object, subject to a `PSmartPointer` instance referencing it.

## Protected Attributes

PAtomicInteger | referenceCount
| Count of number of instances of `PSmartPointer` that currently reference the object instance.

## Detailed Description

This is the base class for objects that use the smart pointer system.

In conjunction with the `PSmartPointer` class, this class creates objects that can have the automatic deletion of the object instance when there are no more smart pointer instances pointing to it.

A `PSmartObject` carries the reference count that the `PSmartPointer` requires to determine if the pointer is needed any more and should be deleted.

## Constructor & Destructor Documentation

PSmartObject::PSmartObject | ( |  | ) | `[inline]`

Construct a new smart object, subject to a `PSmartPointer` instance referencing it.

## Member Data Documentation

PAtomicInteger PSmartObject::referenceCount `[protected]`

Count of number of instances of `PSmartPointer` that currently reference the object instance.

The documentation for this class was generated from the following file:

- smartptr.h